#!/usr/bin/perl

use strict;
use warnings;
use Test::More;

my $nbtest;

# On fait de la concurrence, ne pas numeroter les tests
Test::More->builder->use_numbers(0);

BEGIN { use_ok('FDN::Sql::DB_Access'); }
use_ok('FDN::Common::Config');
my $cfg = Load_Config('./t/dbc.cfg');
is ( ref($cfg), 'HASH', 'dbc.cfg');
BEGIN { $nbtest += 3; }


my $dbh;
$cfg = $cfg->{'test'};
$dbh = connect_db($cfg->{'type'}, $cfg->{'host'}, $cfg->{'name'}, $cfg->{'user'},
	$cfg->{'passwd'} );
is ( ref($dbh), 'HASH', 'connect_db' );
ok ( disconnect_db($dbh), 'diconnect_db' );
BEGIN { $nbtest += 2; }


my $nb_sub1;
subtest 'concurrent 1' => sub {
	plan tests => $nb_sub1;
	Test::More->builder->use_numbers(0);
	my $res;
	if ( fork() ) {
		$res = lock_soft($dbh,'test',10);
		ok ( $res, 'lock_soft');
		# Je tiens le lock pendant 5 secondes.
		sleep(5);
		$res = unlock_soft($dbh, 'test');
		ok ( $res, 'unlock_soft');
		BEGIN { $nb_sub1 += 2; };
	} else {
		sleep(1);
		$res = lock_soft($dbh,'test',2);
		ok ( ! $res, 'lock_soft');
		$res = lock_soft($dbh,'test',10);
		ok ( $res, 'lock_soft');
		$res = unlock_soft($dbh, 'test');
		ok ( $res, 'unlock_soft');
		BEGIN { $nb_sub1 += 3; }
		# Je suis le fils, je meurs.
		if ( ! Test::More->builder->is_passing() ) {
			exit(1); # Echec
		} else {
			exit(0); # Success
		}
	}
	my $wait = wait();
	Test::More->builder->current_test($nb_sub1 - 1);
	is ( $?, 0, 'fin_du_fils' );
	BEGIN { $nb_sub1 += 1; }
};
BEGIN { $nbtest += 1; }


BEGIN { plan tests => $nbtest; }

